<template>
  <div
    class="appWidgetChat"
    :class="{ '_shortcut': !isFull }">
    <AppButtonChat
      :is-online="isOnline"
      :button-text="buttonText"
      @click.native="chatOptions"
      v-tooltip="{
        content: tooltipContent,
        placement: 'bottom',
        html: true,
        trigger: 'hover',
        offset: 4,
        classes: 'tooltipDark',
        delay: 0 }"/>
  </div>
</template>

<script>
// TODO: Виджет ничего не должен знать о нашем сторе
import { createNamespacedHelpers } from 'vuex';

import { SHOW_AUTH_MODAL, SHOW_BEGIN_CHAT_MODAL } from '~/assets/js/store/actionManager/mutation-types';
import { SHOW_ROOM, GET_SHOP_ONLINE_STATUS } from '~/assets/js/store/chat/action-types';
import { SET_OPEN_DIALOG_ONLOAD } from '~/assets/js/store/chat/mutation-types';

import getDialogRequest from '~/assets/js/helpers/chat-get-dialog-request';
import AppButtonChat from '~/components/redesign/app-buttons/app-button-chat';

const STORE_CHAT = createNamespacedHelpers('chat');
const STORE_ACTION_MANAGER = createNamespacedHelpers('actionManager');
const STORE_USER = createNamespacedHelpers('user');

export default {
  name: 'AppWidgetChat',
  components: {
    AppButtonChat,
  },
  props: {
    type: {
      type: String,
      required: true,
      default: '',
    },
    id: {
      type: Number,
      required: true,
      default: 0,
    },
    params: {
      type: Object,
      default() { return {}; },
    },
    showOnline: {
      type: Boolean,
      default: true,
    },
    showButton: {
      type: Boolean,
      default: true,
    },
    buttonText: {
      type: String,
      default: '',
    },
    isFull: {
      type: Boolean,
      default: true,
    },
  },
  data() {
    return {
      loading: false,
      online: {
        status: false,
        loaded: false,
      },
    };
  },
  computed: {
    ...STORE_USER.mapState(['auth']),
    ...STORE_CHAT.mapState({
      isChatOpened: 'opened',
    }),
    isOnline() {
      return this.online.status && this.online.loaded;
    },
    chatOptions() {
      return this.auth ? this.createDialog : this.beginChat;
    },
    tooltipContent() {
      return this.showOnline && this.isOnline ? 'Продавец онлайн' : 'Продавец офлайн';
    },
  },
  mounted() {
    if (this.showOnline) {
      this.loadOnlineStatus();
    }
  },
  methods: {
    ...STORE_ACTION_MANAGER.mapMutations({
      showAuthModal: SHOW_AUTH_MODAL,
      showBeginChatModal: SHOW_BEGIN_CHAT_MODAL,
    }),
    ...STORE_CHAT.mapMutations({
      setOpenRoomOnload: SET_OPEN_DIALOG_ONLOAD,
    }),
    ...STORE_CHAT.mapActions({
      showRoom: SHOW_ROOM,
      getShopOnlineStatus: GET_SHOP_ONLINE_STATUS,
    }),
    beginChat() {
      this.$ym('chat_click_nonauth');
      this.setOpenRoomOnload({
        type: this.type,
        id: this.id,
        params: this.params,
      });
      this.showBeginChatModal();
    },
    loadOnlineStatus() {
      let shopId = null;
      switch (this.type) {
        case 'request':
          break;
        case 'order':
          break;
        case 'shop':
          shopId = this.id;
          break;
        case 'contractPart':
          // вероятно к моменту, когда нужно обрабатывать 'request' & 'order'
          // shopId стоит сделать отдельным Prop
          ({ shopId } = this.params);
          break;
        default:
      }
      if (shopId !== null) {
        this.getShopOnlineStatus({ id: shopId })
          .then((status) => {
            this.online.status = status;
          })
          .finally(() => {
            this.online.loaded = true;
          });
      }
    },
    createDialog() {
      this.$ym('chat_click_auth');
      const promise = getDialogRequest.call(this, this.type, this.id, this.params);
      if (promise !== null) {
        this.loading = true;
        promise
          .then(({ data }) => {
            this.showRoom({ window, roomId: data.roomId, type: data.type });
          }).finally(() => {
            this.loading = false;
          });
      }
    },
  },
};
</script>

<style lang="postcss">
  .appWidgetChat {
    .buttonChat {
      width: 100%;
    }

    @media screen and (min-width: 981px) {
      &._shortcut {
        .buttonChat {
          padding: 0 .75rem;
          height: var(--btn-height-small);
          min-height: var(--btn-height-small);

          .button-label {
            padding: 0 .5rem 0 0;
            color: var(--color-main-lighten);
          }
        }
      }
    }

    @media (min-width: 981px) and (max-width: 1200px) {
      &._shortcut {
        .buttonChat {
          padding: 0 .5rem;
          height: var(--btn-height-medium);
          min-height: var(--btn-height-medium);
        }
      }
    }
  }

</style>
